#include <iostream>
#include <chrono>

class Timer
{
public:
    Timer() = default;
    Timer(int n) : start{std::chrono::high_resolution_clock::now()}, interval{n}, counter{0} {}

    void measure()
    {
        counter++;
        if (!(counter == interval)) return;

        auto end = std::chrono::high_resolution_clock::now();
        auto duration = std::chrono::duration_cast<std::chrono::microseconds>(end - start);

        float fps = interval / (duration.count() / 1'000'000.0f);
        std::cout << "FPS: " << fps << std::endl;
        
        counter = 0;       
        start = end;
     }


private:
    std::chrono::time_point<std::chrono::high_resolution_clock> start;
    int interval;
    int counter;
};
